# Taken from the fedora ruby-2.2.3 .spec. Thanks!

%global major_version 3
%global minor_version 4
%global teeny_version 2
%global major_minor_version %{major_version}.%{minor_version}

%global ruby_version %{major_minor_version}.%{teeny_version}
%global ruby_release %{ruby_version}

%define gem_name_version() %{1}-%{expand:%{%{gsub %{1} - _}_version}}%{?prerelease}
%define gem_spec(d) %{gem_dir}/specifications%{?-d:/default}/%{gem_name_version %{1}}.gemspec
%define gem_instdir() %{gem_dir}/gems/%{gem_name_version %{1}}
%define gem_extdir_mri() %{gem_archdir}/%{name}/%{gem_name_version %{?1}}
%define gem_libdir() %{gem_instdir %{1}}/lib
%define gem_spec(d) %{gem_dir}/specifications%{?-d:/default}/%{gem_name_version %{1}}.gemspec
%define gem_cache() %{gem_dir}/cache/%{gem_name_version %{?1}}.gem
%define gem_plugin() %{gem_dir}/plugins/%{?1}%{!?1:%{gem_name}}_plugin.rb

# Specify the named version. It has precedense to revision.
#%%global milestone rc1

# Keep the revision enabled for pre-releases from GIT.
#%%global revision 5124f9ac75

%global ruby_archive %{name}-%{ruby_version}

# If revision and milestone are removed/commented out, the official release build is expected.
%if 0%{?milestone:1}%{?revision:1} != 0
%global ruby_archive %{ruby_archive}-%{?milestone}%{?!milestone:%{?revision}}
%define ruby_archive_timestamp %(stat --printf='@%Y' %{_sourcedir}/%{ruby_archive}.tar.xz | date -f - +"%Y%m%d")
%define development_release ~%{ruby_archive_timestamp}%{?milestone}%{?!milestone:%{?revision:git%{revision}}}
%endif

# We need to keep this increasing even with new versions of ruby unless all gems get new release :(
%define rel 56
%{!?release_string:%global release_string %mkrel %{?development_release:0.}%{rel}%{?development_release:.%{development_release}}}

# The RubyGems library has to stay out of Ruby directory tree, since the
# RubyGems should be share by all Ruby implementations.
%global rubygems_dir %{_datadir}/rubygems

# Bundled libraries versions
%global rubygems_version 3.6.2
%global rubygems_molinillo_version 0.8.0
%global rubygems_net_http_version 0.6.0
%global rubygems_net_protocol_version 0.2.2
%global rubygems_optparse_version 0.6.0
%global rubygems_resolv_version 0.6.0
%global rubygems_securerandom_version 0.4.1
%global rubygems_timeout_version 0.4.3
%global rubygems_tsort_version 0.2.0
%global rubygems_uri_version 1.0.2

# Default gems.
%global bundler_version 2.6.2
%global bundler_connection_pool_version 2.4.1
%global bundler_fileutils_version 1.7.3
%global bundler_net_http_persistent_version 4.0.4
%global bundler_pub_grub_version 0.5.0
%global bundler_securerandom_version 0.4.1
%global bundler_thor_version 1.3.2
%global bundler_tsort_version 0.2.0
%global bundler_uri_version 1.0.2

%global benchmark_version 0.4.0
%global cgi_version 0.4.1
%global date_version 3.4.1
%global delegate_version 0.4.0
%global did_you_mean_version 2.0.0
%global digest_version 3.2.0
%global english_version 0.8.0
%global erb_version 4.0.4
%global error_highlight_version 0.7.0
%global etc_version 1.4.5
%global fcntl_version 1.2.0
%global fiddle_version 1.1.6
%global fileutils_version 1.7.3
%global find_version 0.2.0
%global forwardable_version 1.3.3
%global io_nonblock_version 0.3.1
%global io_wait_version 0.3.1
%global ipaddr_version 1.2.7
%global logger_version 1.6.4
%global net_http_version 0.6.0
%global net_protocol_version 0.2.2
%global open3_version 0.2.1
%global openssl_version 3.3.0
%global open_uri_version 0.5.0
%global optparse_version 0.6.0
%global ostruct_version 0.6.1
%global pathname_version 0.4.0
%global pp_version 0.6.2
%global prettyprint_version 0.2.0
%global prism_version 1.2.0
%global pstore_version 0.1.4
%global readline_version 0.0.4
%global reline_version 0.6.0
%global resolv_version 0.6.0
%global ruby2_keywords_version 0.0.5
%global securerandom_version 0.4.1
%global set_version 1.1.1
%global shellwords_version 0.2.2
%global singleton_version 0.3.0
%global stringio_version 3.1.2
%global strscan_version 3.1.2
%global syntax_suggest_version 2.0.2
%global syslog_version 0.2.0
%global tempfile_version 0.3.1
%global time_version 0.4.1
%global timeout_version 0.4.3
%global tmpdir_version 0.3.1
%global tsort_version 0.2.0
%global un_version 0.3.0
%global uri_version 1.0.2
%global weakref_version 0.1.3
%global win32ole_version 1.9.1
%global win32_registry_version 0.1.0
%global yaml_version 0.4.0
%global zlib_version 3.2.1

# Gemified default gems.
%global io_console_version 0.8.0
%global irb_version 1.14.3
%global json_version 2.9.1
%global psych_version 5.2.2
%global rdoc_version 6.10.0

# Bundled gems.
%global abbrev_version 0.1.2
%global base64_version 0.2.0
%global bigdecimal_version 3.1.8
%global csv_version 3.3.2
%global debug_version 1.10.0
%global drb_version 2.2.1
%global getoptlong_version 0.2.1
%global net_ftp_version 0.3.8
%global net_imap_version 0.5.6
%global net_pop_version 0.1.2
%global net_smtp_version 0.5.1
%global nkf_version 0.2.0
%global matrix_version 0.4.2
%global minitest_version 5.25.4
%global mutex_m_version 0.3.0
%global observer_version 0.1.2
%global power_assert_version 2.0.5
%global prime_version 0.1.3
%global racc_version 1.8.1
%global rake_version 13.2.1
%global rbs_version 3.8.0
%global repl_type_completor_version 0.1.9
%global resolv_replace_version 0.1.1
%global rexml_version 3.4.0
%global rinda_version 0.2.0
%global rss_version 0.3.1
%global syslog_version 0.2.0
%global test_unit_version 3.6.7
%global typeprof_version 0.30.1


# Bundled nkf version
%global bundled_nkf_version 2.1.5

%global tapset_libdir %(echo %{_libdir} | sed 's/64//')*

%bcond_without rubypick
%bcond_without cmake
%bcond_without git
%bcond_without gmp
%bcond_without hostname
%bcond_without systemtap
# YJIT is supported on x86_64 and aarch64.
# https://github.com/ruby/ruby/blob/master/doc/yjit/yjit.md
%ifarch x86_64 aarch64
%bcond_without yjit
%endif
# Enable test when building on local.
%bcond_with bundler_tests

%bcond_with hardening_test

# The additional linker flags break binary rubygem- packages.
# https://bugzilla.redhat.com/show_bug.cgi?id=2043092
%undefine _package_note_flags

# Additional defines by Mageia.

%define subver %{major_minor_version}
%define rubyapi %{subver}.%{teeny_version}
%define rubyver %{ruby_version}

%define libname %mklibname ruby %{subver}

%global ruby_libdir %{_datadir}/%{name}
%global ruby_libarchdir %{_libdir}/%{name}

# This is the local lib/arch and should not be used for packaging.
%global ruby_sitedir site_ruby
%global ruby_sitelibdir %{_prefix}/local/share/%{name}/%{ruby_sitedir}
%global ruby_sitearchdir %{_prefix}/local/%{_lib}/%{name}/%{ruby_sitedir}

# This is the general location for libs/archs compatible with all
# or most of the Ruby versions available in the Fedora repositories.
%global ruby_vendordir vendor_ruby
%global ruby_vendorlibdir %{ruby_libdir}/%{ruby_vendordir}
%global ruby_vendorarchdir %{ruby_libarchdir}/%{ruby_vendordir}

# The RubyGems library has to stay out of Ruby directory tree, since the
# RubyGems should be shared by all Ruby implementations.
%define gem_dir %{_datadir}/gems
%define gem_archdir %{_libdir}/gems

Summary:	Object Oriented Script Language
Name:		ruby
Version:	%{rubyver}
Release: 	%release_string
License:	Ruby or BSD
Group:		Development/Ruby
BuildRequires:	autoconf
BuildRequires:	byacc
BuildRequires:	bison
BuildRequires:	doxygen
BuildRequires:	pkgconfig(ncurses)
BuildRequires:  pkgconfig(openssl)
BuildRequires:	pkgconfig(zlib)
BuildRequires:	pkgconfig(libffi)
BuildRequires:	pkgconfig(yaml-0.1)
BuildRequires:	readline-devel
BuildRequires:	db-devel
BuildRequires:  gdbm-devel >= 1.8.3
BuildRequires:	rpm-mageia-setup >= 1.158
# Needed to pass test_set_program_name(TestRubyOptions)
BuildRequires:	procps
# This causes gems to be installed in the home directory and breaks build
BuildConflicts:	ruby-RubyGems
%{?with_systemtap:BuildRequires: systemtap-sdt-devel}
%{?with_yjit:BuildRequires: rust}
Conflicts:	ruby-devel < 2.0.0.p451-4.mga5
# StdLib default gems.
Provides:	bundled(rubygem-did_you_mean) = %{did_you_mean_version}
Provides:	bundled(rubygem-openssl) = %{openssl_version}
# Tcl/Tk support was removed from stdlib in Ruby 2.4
Obsoletes:	ruby-tk < 2.4.0
# explicit file provides (since such requires are automatically added by find-requires)
Provides:	/usr/bin/ruby
Provides:	ruby(abi) = %subver
Provides:	ruby(release) = %rubyver
Requires:	ruby-RubyGems >= %rubygems_version
Provides:	rubygem(did_you_mean) = %{did_you_mean_version}
Provides:	rubygem(openssl) = %{openssl_version}
Provides:	rubygem(stringio) = %{stringio_version}
Obsoletes:	ruby-did_you_mean < 1.4.0-36
Obsoletes:	ruby-openssl < 2.7.2-36
URL:		https://ruby-lang.org/
Source0:	https://ftp.ruby-lang.org/pub/ruby/%{subver}/ruby-%{rubyver}.tar.xz
Source1:	operating_system.rb
Source2:	libruby.stp
Source3:	ruby-exercise.stp
# Similar to FC:
Source4:	macros.ruby
Source5:	macros.rubygems
Source100:	rubygems.req.no-rich-deps.patch
# From FC:
# RPM dependency generators.
Source8: rubygems.attr
Source9: rubygems.req
Source10: rubygems.prov
Source11: rubygems.con
# ABRT hoook test case.
Source13: test_abrt.rb
# SystemTap tests.
Source14: test_systemtap.rb
# RPM gem Requires dependency generator tests.
Source16: rpm_test_helper.rb
Source17: test_rubygems_req.rb
Source18: test_rubygems_prov.rb
Source19: test_rubygems_con.rb
# This file is available in official RDoc 6.9+, while it is missing from
# default RDoc gem as shipped in Ruby tarball. This should not be needed for
# Ruby 3.5+.
Source20: https://github.com/ruby/rdoc/blob/master/lib/rubygems_plugin.rb

%define _local_file_attrs local_generator
%define __local_generator_requires make -C %{_builddir}/%{buildsubdir}/%{_vpath_builddir} -s runruby TESTRUN_SCRIPT="--enable-gems %{buildroot}%{_rpmconfigdir}/rubygems.req"
%define __local_generator_provides make -C %{_builddir}/%{buildsubdir}/%{_vpath_builddir} -s runruby TESTRUN_SCRIPT="--enable-gems %{SOURCE10}"
%define __local_generator_conflicts make -C %{_builddir}/%{buildsubdir}/%{_vpath_builddir} -s runruby TESTRUN_SCRIPT="--enable-gems %{SOURCE11}"
%define __local_generator_path ^%{gem_dir}/specifications/.*\.gemspec$

# == FEDORA PATCHES BEGINS ==
# Fix ruby_version abuse.
# https://bugs.ruby-lang.org/issues/11002
Patch0: ruby-2.3.0-ruby_version.patch
# http://bugs.ruby-lang.org/issues/7807
Patch1: ruby-2.1.0-Prevent-duplicated-paths-when-empty-version-string-i.patch
# Allows to override libruby.so placement. Hopefully we will be able to return
# to plain --with-rubyarchprefix.
# http://bugs.ruby-lang.org/issues/8973
Patch2: ruby-2.1.0-Enable-configuration-of-archlibdir.patch
# Force multiarch directories for i.86 to be always named i386. This solves
# some differencies in build between Fedora and RHEL.
Patch3: ruby-2.1.0-always-use-i386.patch
# Allows to install RubyGems into custom directory, outside of Ruby's tree.
# http://bugs.ruby-lang.org/issues/5617
Patch4: ruby-2.1.0-custom-rubygems-location.patch
# The ABRT hook used to be initialized by preludes via following patches:
# https://bugs.ruby-lang.org/issues/8566
# https://bugs.ruby-lang.org/issues/15306
# Unfortunately, due to https://bugs.ruby-lang.org/issues/16254
# and especially since https://github.com/ruby/ruby/pull/2735
# this would require boostrapping:
# https://lists.fedoraproject.org/archives/list/ruby-sig@lists.fedoraproject.org/message/LH6L6YJOYQT4Y5ZNOO4SLIPTUWZ5V45Q/
# For now, load the ABRT hook via this simple patch:
Patch6: ruby-2.7.0-Initialize-ABRT-hook.patch
# Disable syntax_suggest test suite, which tries to download its dependencies.
# https://bugs.ruby-lang.org/issues/19297
Patch9: ruby-3.3.0-Disable-syntax-suggest-test-case.patch

%package	-n %{libname}
Summary:	Libraries necessary to run Ruby
Group:		Development/Ruby

%package	doc
Summary:	Documentation for the powerful language Ruby
Group:		Development/Ruby
BuildArch:	noarch

%package	devel
Summary:	Development file for the powerful language Ruby
Group:		Development/Ruby
Requires:	%{name} = %{version}
Requires:	%{libname} = %{version}

%package	RubyGems
Summary:	The Ruby standard for packaging ruby libraries
Group:		Development/Ruby
Version:	%{rubygems_version}
Requires:	ruby(abi) = %{subver}
Requires:	rubygem(json) >= %{json_version}
Requires:	rubygem(openssl) >= %{openssl_version}
Requires:	rubygem(psych) >= %{psych_version}
# This should probably not be a strict require but --rdoc/--ri fail badly without it
Requires:	rubygem(rdoc) >= %{rdoc_version}
Provides:	gem = %{rubygems_version}
Provides:	rubygems = %{rubygems_version}
Provides:	ruby(rubygems) = %{rubygems_version}
Conflicts:	rpm-mageia-setup-build < 1.159
Conflicts:	ruby < 2.4.1-10
BuildArch:	noarch

%package	rake
Summary:	Simple ruby build program with capabilities similar to make
Group:		Development/Ruby
Version:	%{rake_version}
Requires:	ruby(abi) = %{subver}
Provides:	rubygem(rake) = %{version}
BuildArch:	noarch

%package	rbs
Summary:	Type signature for Ruby
Version:	%{rbs_version}
License:	Ruby or BSD
Requires:	ruby(abi) = %{subver}
Requires:	ruby(rubygems) >= %{rubygems_version}
Provides:	rubygem(rbs) = %{version}-%{release}

%description	rbs
RBS is the language for type signatures for Ruby and standard library
definitions.


%package	minitest
Summary:	Minitest provides a complete suite of testing facilities
Group:		Development/Ruby
Version:	%{minitest_version}
License:	MIT
Requires:	ruby(abi) = %{subver}
Requires:	ruby(rubygems) >= %{rubygems_version}
Provides:	rubygem(minitest) = %{version}
BuildArch:	noarch

%package	power_assert
Summary:	Power Assert for Ruby
Group:		Development/Ruby
Version:	%{power_assert_version}
License:	BSD
Requires:	ruby(abi) = %{subver}
Requires:	ruby(rubygems) >= %{rubygems_version}
Provides:	rubygem(power_assert) = %{version}
BuildArch:	noarch

%package	json
Summary:	This is a JSON implementation as a Ruby extension in C
Group:		Development/Ruby
Version:	%{json_version}
License:	Ruby or GPLv2
Requires:	ruby(abi) = %{subver}
Requires:	ruby(rubygems) >= %{rubygems_version}
Provides:	rubygem(json) = %{version}
Conflicts:	ruby < 2.4.1

%package	rdoc
Summary:	A tool to generate HTML and command-line documentation for Ruby projects
Group:		Development/Ruby
Version:	%{rdoc_version}
License:	GPLv2 and Ruby and MIT
Requires:	ruby(abi) = %{subver}
Requires:	ruby(rubygems) >= %{rubygems_version}
Requires:	rubygem(irb) = %{irb_version}
Requires:	rubygem(io-console) >= %{io_console_version}
Requires:	rubygem(json) >= %{json_version}
Provides:	rubygem(rdoc) = %{version}
Provides:	rdoc = %{rdoc_version}
Provides:	ri = %{rdoc_version}
BuildArch:	noarch

%package	irb
Summary:	The Interactive Ruby
Group:		Development/Ruby
Provides:	irb = %{irb_version}-%{release}
Provides:	rubygem(irb) = %{irb_version}-%{release}
Conflicts:	ruby < 1.9
BuildArch:	noarch

%package	bigdecimal
Summary:	BigDecimal provides arbitrary-precision floating point decimal arithmetic
Group:		Development/Ruby
Version:	%{bigdecimal_version}
License:	GPL+ or Artistic
Requires:	ruby(abi) = %{subver}
Provides:	rubygem(bigdecimal) = %{version}
Requires:	ruby(rubygems) >= %{rubygems_version}

%package	io-console
Summary:	IO/Console is a simple console utilizing library
Group:		Development/Ruby
Version:	%{io_console_version}
Requires:	ruby(abi) = %{subver}
Requires:	ruby(rubygems) >= %{rubygems_version}
Provides:	rubygem(io-console) = %{version}

%package	psych
Summary:	A libyaml wrapper for Ruby
Version:	%{psych_version}
Group:		Development/Ruby
License:	MIT
Requires:	ruby(abi) = %{subver}
Requires:	ruby(rubygems) >= %{rubygems_version}
Provides:	rubygem(psych) = %{version}
Conflicts:	ruby < 2.4.1-11

%package	test-unit
Summary:	test/unit compatible API testing framework
Version:	%{test_unit_version}
Group:		Development/Ruby
License:	MIT
Provides:	rubygem(test-unit) = %{test_unit_version}
Requires:	ruby(abi) = %{subver}
Requires:	ruby(rubygems) >= %{rubygems_version}
Provides:	rubygem(test-unit) = %{version}
Conflicts:	ruby < 2.0.0
BuildArch:	noarch

%package	bundler
Summary:	Library and utilities to manage a Ruby application's gem dependencies
Version:	%{bundler_version}
License:	MIT
Requires:	ruby(rubygems) >= %{rubygems_version}
Requires:	rubygem(io-console)
Provides:	rubygem(bundler) = %{version}-%{release}
BuildArch:	noarch

%package	bundled-gems
Summary:	Bundled gems which are part of Ruby StdLib
Requires:	ruby(rubygems) >= %{rubygems_version}
Provides:	bundled(rubygem-abbrev) = %{abbrev_version}
Provides:	bundled(rubygem-base64) = %{base64_version}
Provides:	bundled(rubygem-csv) = %{csv_version}
Provides:	bundled(rubygem-debug) = %{debug_version}
Provides:	bundled(rubygem-drb) = %{drb_version}
Provides:	bundled(rubygem-getoptlong) = %{getoptlong_version}
Provides:	bundled(rubygem-matrix) = %{matrix_version}
Provides:	bundled(rubygem-mutex_m) = %{mutex_m_version}
Provides:	bundled(rubygem-net-ftp) = %{net_ftp_version}
Provides:	bundled(rubygem-net-imap) = %{net_imap_version}
Provides:	bundled(rubygem-net-pop) = %{net_pop_version}
Provides:	bundled(rubygem-net-smtp) = %{net_smtp_version}
Provides:	bundled(rubygem-nkf) = %{nkf_version}
Provides:	bundled(rubygem-prime) = %{prime_version}
Provides:	bundled(rubygem-observer) = %{observer_version}
Provides:	bundled(rubygem-repl_type_completor) = %{repl_type_completor_version}
Provides:	bundled(rubygem-resolv-replace) = %{resolv_replace_version}
Provides:	bundled(rubygem-rinda) = %{rinda_version}
Provides:	bundled(rubygem-syslog) = %{syslog_version}

%package	racc
Version:	%{racc_version}
Summary:	Racc is a LALR(1) parser generator
License:	Ruby OR BSD-2-Clause
URL:		https://github.com/ruby/racc

%description	racc
Racc is a LALR(1) parser generator.
It is written in Ruby itself, and generates Ruby program.

%package	rexml
Summary:	An XML toolkit for Ruby
Version:	%{rexml_version}
License:	BSD
URL:		https://github.com/ruby/rexml
Requires:	ruby(rubygems) >= %{rubygems_version}
Provides:	rubygem(rexml) = %{version}-%{release}
BuildArch:	noarch

%description rexml
REXML was inspired by the Electric XML library for Java, which features an
easy-to-use API, small size, and speed. Hopefully, REXML, designed with the same
philosophy, has these same features. I've tried to keep the API as intuitive as
possible, and have followed the Ruby methodology for method naming and code
flow, rather than mirroring the Java API.

REXML supports both tree and stream document parsing. Stream parsing is faster
(about 1.5 times as fast). However, with stream parsing, you don't get access to
features such as XPath.

%package	rss
Summary:	Family of libraries that support various formats of XML "feeds"
Version:	%{rss_version}
License:	BSD
URL:		https://github.com/ruby/rss
Requires:	ruby(rubygems) >= %{rubygems_version}
Provides:	rubygem(rss) = %{version}-%{release}
BuildArch:	noarch

%package typeprof
Summary:	TypeProf is a type analysis tool for Ruby code based on abstract interpretation
Version:	%{typeprof_version}
License:	MIT
URL:		https://github.com/ruby/typeprof
Requires:	ruby(rubygems) >= %{rubygems_version}
Requires:	rubygem(rbs) >= %{rbs_version}
Provides:	rubygem(typeprof) = %{version}-%{release}
BuildArch:	noarch

%description
Ruby is the interpreted scripting language for quick and
easy object-oriented programming.  It has many features to
process text files and to do system management tasks (as in
Perl).  It is simple, straight-forward, and extensible.

%description	doc
Ruby is the interpreted scripting language for quick and
easy object-oriented programming.  It has many features to
process text files and to do system management tasks (as in
Perl). It is simple, straight-forward, and extensible.

This package contains the Ruby's documentation

%description	-n %{libname}
This package includes the libruby, necessary to run Ruby.

%description	devel
Ruby is the interpreted scripting language for quick and
easy object-oriented programming.  It has many features to
process text files and to do system management tasks (as in
Perl). It is simple, straight-forward, and extensible.

This package contains the Ruby's devel files.

%description	RubyGems
RubyGems is the Ruby standard for publishing and managing third party
libraries.

%description	rake
Rake is a Make-like program implemented in Ruby. Tasks and dependencies are
specified in standard Ruby syntax.

%description 	rdoc
RDoc produces HTML and command-line documentation for Ruby projects.  RDoc
includes the 'rdoc' and 'ri' tools for generating and displaying online
documentation.

%description	json
This is a implementation of the JSON specification according to RFC 4627.
You can think of it as a low fat alternative to XML, if you want to store
data to disk or transmit it over a network rather than use a verbose
markup language.

%description	minitest
minitest/unit is a small and incredibly fast unit testing framework.

minitest/spec is a functionally complete spec engine.

minitest/benchmark is an awesome way to assert the performance of your
algorithms in a repeatable manner.

minitest/mock by Steven Baker, is a beautifully tiny mock object
framework.

minitest/pride shows pride in testing and adds coloring to your test
output.
  
%description	power_assert
Power Assert shows each value of variables and method calls in the expression.
It is useful for testing, providing which value wasn't correct when the
condition is not satisfied.

%description	irb
The irb is acronym for Interactive Ruby.  It evaluates ruby expression
from the terminal.

%description	bigdecimal
Ruby provides built-in support for arbitrary precision integer arithmetic.
For example:

42**13 -> 1265437718438866624512

BigDecimal provides similar support for very large or very accurate floating
point numbers. Decimal arithmetic is also useful for general calculation,
because it provides the correct answers people expect–whereas normal binary
floating point arithmetic often introduces subtle errors because of the
conversion between base 10 and base 2.

%description	io-console
IO/Console provides very simple and portable access to console. It doesn't
provide higher layer features, such like curses and readline.

%description	psych
Psych is a YAML parser and emitter. Psych leverages
libyaml[http://pyyaml.org/wiki/LibYAML] for its YAML parsing and emitting
capabilities. In addition to wrapping libyaml, Psych also knows how to
serialize and de-serialize most Ruby objects to and from the YAML format.

%description	test-unit
This library implements test/unit compatible API on minitest.
The test/unit means that test/unit which was bundled with Ruby 1.8.

%description	bundler
Bundler manages an application's dependencies through its entire life, across
many machines, systematically and repeatably.

%description	bundled-gems
Bundled gems which are part of Ruby StdLib. While being part of Ruby, these
needs to be listed in Gemfile to be used by Bundler.

%description	typeprof
TypeProf performs a type analysis of non-annotated Ruby code.
It abstractly executes input Ruby code in a level of types instead of values,
gathers what types are passed to and returned by methods, and prints the
analysis result in RBS format, a standard type description format for Ruby
3.0.

%description	rss
Really Simple Syndication (RSS) is a family of formats that describe 'feeds',
specially constructed XML documents that allow an interested person to subscribe
and receive updates from a particular web service. This library provides tooling
to read and create these feeds.

%prep
%setup -q -n ruby-%{rubyver}
%autopatch -p1

%build
autoreconf -vfi
CFLAGS=`echo %optflags | sed 's/-fomit-frame-pointer//'`

%global _configure %{_builddir}/%{buildsubdir}/configure

mkdir -p %{_vpath_builddir}
pushd %{_vpath_builddir}

%configure --enable-shared --disable-rpath --enable-pthread \
        --enable-multiarch \
        --with-rubylibprefix='%{ruby_libdir}' \
        --with-archlibdir='%{_libdir}' \
        --with-rubyarchprefix='%{ruby_libarchdir}' \
        --with-sitedir='%{ruby_sitelibdir}' \
        --with-sitearchdir='%{ruby_sitearchdir}' \
        --with-vendordir='%{ruby_vendorlibdir}' \
        --with-vendorarchdir='%{ruby_vendorarchdir}' \
        --with-rubyhdrdir='%{_includedir}' \
        --with-rubyarchhdrdir='%{_includedir}' \
        --with-sitearchhdrdir='$(sitehdrdir)/$(arch)' \
        --with-vendorarchhdrdir='$(vendorhdrdir)/$(arch)' \
        --with-rubygemsdir='%{rubygems_dir}' \
        --with-ruby-pc='%{name}.pc' \
        --with-compress-debug-sections=no \
        --disable-rpath \
        --enable-mkmf-verbose \
        --enable-shared \
        --with-ruby-version='' \
        --enable-multiarch \
        %{?with_yjit: --enable-yjit} \

popd

# V=1 in %%make_build outputs the compiler options more verbosely.
# https://bugs.ruby-lang.org/issues/18756
%make_build COPY="cp -p" -C %{_vpath_builddir}

%install
rm -rf %{buildroot}

%make_install -C %{_vpath_builddir}

# TODO: Regenerate RBS parser in lib/rbs/parser.rb

# Rename ruby/config.h to ruby/config-<arch>.h to avoid file conflicts on
# multilib systems and install config.h wrapper
%multiarch_includes %{buildroot}%{_includedir}/%{name}/config.h

# `ruby` executable is placed in some strange directory for some unknow
# reasons.
# https://bugs.ruby-lang.org/issues/20800
# https://github.com/ruby/ruby/pull/12043
CONFIG_TARGET_DIR=%{buildroot}%{_exec_prefix}/$( \
  %{_vpath_builddir}/miniruby -I%{_vpath_builddir} -rrbconfig -e 'puts RbConfig::CONFIG["config_target"]'
)
mv ${CONFIG_TARGET_DIR}/bin/ruby %{buildroot}%{_bindir}
rm -rd ${CONFIG_TARGET_DIR}

# Kill bundled certificates, as they should be part of ca-certificates.
for cert in \
  rubygems.org/GlobalSignRootCA.pem \
  rubygems.org/GlobalSignRootCA_R3.pem
do
  rm %{buildroot}%{rubygems_dir}/rubygems/ssl_certs/$cert
  rm -d $(dirname %{buildroot}%{rubygems_dir}/rubygems/ssl_certs/$cert) || :
done

# Ensure there is not forgotten any certificate.
test ! "$(ls -A  %{buildroot}%{rubygems_dir}/rubygems/ssl_certs/ 2>/dev/null)"

# Move macros file into proper place
mkdir -p %{buildroot}%{_rpmconfigdir}/macros.d
install -m 644 %{SOURCE4} %{buildroot}%{_rpmconfigdir}/macros.d/macros.ruby

install -m 644 %{SOURCE5} %{buildroot}%{_rpmconfigdir}/macros.d/macros.rubygems

# Install dependency generators.
mkdir -p %{buildroot}%{_rpmconfigdir}/fileattrs
install -m 644 %{SOURCE8} %{buildroot}%{_rpmconfigdir}/fileattrs
install -m 755 %{SOURCE9} %{buildroot}%{_rpmconfigdir}
patch %{buildroot}%{_rpmconfigdir}/rubygems.req < %{SOURCE100}
install -m 755 %{SOURCE10} %{buildroot}%{_rpmconfigdir}
install -m 755 %{SOURCE11} %{buildroot}%{_rpmconfigdir}

# Install custom operating_system.rb.
mkdir -p %{buildroot}%{rubygems_dir}/rubygems/defaults
cp %{SOURCE1} %{buildroot}%{rubygems_dir}/rubygems/defaults

# Move gems root into common direcotry, out of Ruby directory structure.
mv %{buildroot}%{ruby_libdir}/gems %{buildroot}%{gem_dir}

# Create folders for gem binary extensions.
mkdir -p %{buildroot}%{_exec_prefix}/lib{,64}/gems/%{name}

# Version is empty if --with-ruby-version is specified.
# http://bugs.ruby-lang.org/issues/7807
sed -i 's/Version: .*/Version: %{rubyver}/' %{buildroot}%{_libdir}/pkgconfig/%{name}.pc

# Move bundled rubygems to %%gem_dir and %%gem_extdir_mri
# make symlinks for io-console, which is considered to be part of stdlib by other Gems
mkdir -p %{buildroot}%{gem_libdir irb}
mv %{buildroot}%{ruby_libdir}/irb* %{buildroot}%{gem_libdir irb}
mv %{buildroot}%{gem_spec -d irb} %{buildroot}%{gem_spec irb}
ln -s %{gem_libdir irb}/irb.rb %{buildroot}%{ruby_libdir}/irb.rb
# TODO: This should be possible to replaced by simple directory symlink
# after ~ F31 EOL (rhbz#1691039).
mkdir -p %{buildroot}%{ruby_libdir}/irb
pushd %{buildroot}%{gem_dir}/gems/irb-%{irb_version}/lib
find irb -type d -mindepth 1 -exec mkdir %{buildroot}%{ruby_libdir}/'{}' \;
find irb -type f -exec ln -s %{gem_libdir irb}/'{}' %{buildroot}%{ruby_libdir}/'{}' \;
popd

mkdir -p %{buildroot}%{gem_libdir rdoc}
mv %{buildroot}%{ruby_libdir}/rdoc* %{buildroot}%{gem_libdir rdoc}
mv %{buildroot}%{gem_spec -d rdoc} %{buildroot}%{gem_spec rdoc}
# Default gem is missing the RubyGems plugin, using various sorts of
# heuristics to workadound this. Restore the plugin to let the documentaion
# generator work properly. This shold not be needed for Ruby 3.5+.
# https://github.com/ruby/rdoc/pull/1171
# https://github.com/rubygems/rubygems/pull/8340
# Make sure to not overwrite the file, because it should not exist.
test ! -e %{buildroot}%{gem_libdir rdoc}/%{basename:%{SOURCE20}}
cp -a %{SOURCE20} %{buildroot}%{gem_libdir rdoc}
echo "require_relative '../gems/rdoc-%{rdoc_version}/lib/rubygems_plugin.rb'" \
  > %{buildroot}%{gem_plugin rdoc}

# TODO: Put help files into proper location.
# https://bugs.ruby-lang.org/issues/15359
mkdir -p %{buildroot}%{gem_libdir bundler}
mv %{buildroot}%{ruby_libdir}/bundler.rb %{buildroot}%{gem_libdir bundler}
mv %{buildroot}%{ruby_libdir}/bundler %{buildroot}%{gem_libdir bundler}
mv %{buildroot}%{gem_spec -d bundler} %{buildroot}%{gem_spec bundler}

mkdir -p %{buildroot}%{gem_libdir io-console}
mkdir -p %{buildroot}%{gem_extdir_mri io-console}/io
mv %{buildroot}%{ruby_libdir}/io %{buildroot}%{gem_libdir io-console}
mv %{buildroot}%{ruby_libarchdir}/io/console.so %{buildroot}%{gem_extdir_mri io-console}/io
touch %{buildroot}%{gem_extdir_mri io-console}/gem.build_complete
mv %{buildroot}%{gem_spec -d io-console} %{buildroot}%{gem_spec io-console}
ln -s %{gem_libdir io-console}/io %{buildroot}%{ruby_libdir}/io
ln -s %{gem_extdir_mri io-console}/io/console.so %{buildroot}%{ruby_libarchdir}/io/console.so

mkdir -p %{buildroot}%{gem_libdir json}
mkdir -p %{buildroot}%{gem_extdir_mri json}
mv %{buildroot}%{ruby_libdir}/json* %{buildroot}%{gem_libdir json}
mv %{buildroot}%{ruby_libarchdir}/json/ %{buildroot}%{gem_extdir_mri json}
touch %{buildroot}%{gem_extdir_mri json}/gem.build_complete
mv %{buildroot}%{gem_spec -d json} %{buildroot}%{gem_spec json}
ln -s %{gem_libdir json}/json.rb %{buildroot}%{ruby_libdir}/json.rb
ln -s %{gem_libdir json}/json %{buildroot}%{ruby_libdir}/json
ln -s %{gem_extdir_mri json}/json/ %{buildroot}%{ruby_libarchdir}/json

mkdir -p %{buildroot}%{gem_libdir psych}
mkdir -p %{buildroot}%{gem_extdir_mri psych}
mv %{buildroot}%{ruby_libdir}/psych* %{buildroot}%{gem_libdir psych}
mv %{buildroot}%{ruby_libarchdir}/psych.so %{buildroot}%{gem_extdir_mri psych}
touch %{buildroot}%{gem_extdir_mri psych}/gem.build_complete
mv %{buildroot}%{gem_spec -d psych} %{buildroot}%{gem_spec psych}
ln -s %{gem_libdir psych}/psych %{buildroot}%{ruby_libdir}/psych
ln -s %{gem_libdir psych}/psych.rb %{buildroot}%{ruby_libdir}/psych.rb
ln -s %{gem_extdir_mri psych}/psych.so %{buildroot}%{ruby_libarchdir}/psych.so

# Move the binary extensions into proper place (if no gem has binary extension,
# the extensions directory might be empty).
# TODO: Get information about extension form .gemspec files.
find %{buildroot}%{gem_dir}/extensions/*-%{_target_os}*/%{major_minor_version}.*/* -maxdepth 0 \
  -exec mv '{}' %{buildroot}%{_libdir}/gems/%{name}/ \; \
  || echo "No gem binary extensions to move."

# Remove the extension sources and library copies from `lib` dir.
find %{buildroot}%{gem_dir}/gems/*/ext -maxdepth 0 -exec rm -rf '{}' +
find %{buildroot}%{gem_dir}/gems/*/lib -name \*.so -delete

# Move man pages into proper location
mkdir -p %{buildroot}%{_mandir}/man{1,5}
mv %{buildroot}%{gem_instdir rake}/doc/rake.1 %{buildroot}%{_mandir}/man1
# https://bugs.ruby-lang.org/issues/17778
cp -a %{buildroot}%{gem_libdir bundler}/bundler/man/*.1 %{buildroot}%{_mandir}/man1
cp -a %{buildroot}%{gem_libdir bundler}/bundler/man/*.5 %{buildroot}%{_mandir}/man5

%if %{with systemtap}
# Install a tapset and fix up the path to the library.
mkdir -p %{buildroot}%{_systemtap_tapsetdir}
sed -e "s|@LIBRARY_PATH@|%{tapset_libdir}/libruby.so.%{major_minor_version}|" \
  %{SOURCE2} > %{buildroot}%{_systemtap_tapsetdir}/libruby.so.%{major_minor_version}.stp
# Escape '*/' in comment.
sed -i -r "s|( \*.*\*)\/(.*)|\1\\\/\2|" %{buildroot}%{_systemtap_tapsetdir}/libruby.so.%{major_minor_version}.stp
%endif

# Prepare -doc subpackage file lists.
find doc -maxdepth 1 -type f ! -name '.*' ! -name '*.ja*' > .ruby-doc.en
echo 'doc/images' >> .ruby-doc.en
echo 'doc/syntax' >> .ruby-doc.en

find doc -maxdepth 1 -type f -name '*.ja*' > .ruby-doc.ja
echo 'doc/irb' >> .ruby-doc.ja
echo 'doc/pty' >> .ruby-doc.ja

sed -i 's/^/%doc /' .ruby-doc.*
sed -i 's/^/%lang(ja) /' .ruby-doc.ja

%check
%if 0%{?with_hardening_test}
# Check Ruby hardening.
%define fortification_x86_64  fortified="12" fortify-able="29"
%define fortification_i686    fortified="10" fortify-able="26"
%define fortification_aarch64 fortified="12" fortify-able="29"
%define fortification_ppc64le fortified="7" fortify-able="24"
%define fortification_s390x   fortified="10" fortify-able="24"
%define fortification_riscv64 fortified="10" fortify-able="26"
# https://unix.stackexchange.com/questions/366/convince-grep-to-output-all-lines-not-just-those-with-matches
checksec --format=xml --file=%{_vpath_builddir}/libruby.so.%{ruby_version} | \
  sed -r "s/<file (.*)\/>/\1/" | \
  sed -nr $'/relro="full" canary="yes" nx="yes" pie="dso" rpath="no" runpath="no" symbols="yes" fortify_source="partial" %{expand:%{fortification_%{_target_cpu}}} filename='\''redhat-linux-build\/libruby.so.%{ruby_version}'\''/h; ${p;x;/./Q0;Q1}'
%endif

# Check RubyGems version.
[ "`make -C %{_vpath_builddir} -s runruby TESTRUN_SCRIPT='%{_builddir}/%{buildsubdir}/bin/gem -v' | tail -1`" == '%{rubygems_version}' ]

# Check Rubygems bundled dependencies versions.

# Molinillo.
make -C %{_vpath_builddir} -s runruby TESTRUN_SCRIPT="-e \" \
  module Gem; module Resolver; end; end; \
  require 'rubygems/vendor/molinillo/lib/molinillo/gem_metadata'; \
  puts '%%{rubygems_molinillo_version}: %{rubygems_molinillo_version}'; \
  puts %Q[Gem::Molinillo::VERSION: #{Gem::Molinillo::VERSION}]; \
  exit 1 if Gem::Molinillo::VERSION != '%{rubygems_molinillo_version}'; \
\""

# Net::HTTP.
make -C %{_vpath_builddir} -s runruby TESTRUN_SCRIPT="-e \" \
  module Gem; module Net; end; end; \
  require 'rubygems/vendor/net-http/lib/net/http'; \
  puts '%%{rubygems_net_http_version}: %{rubygems_net_http_version}'; \
  puts %Q[Gem::Net::HTTP::VERSION: #{Gem::Net::HTTP::VERSION}]; \
  exit 1 if Gem::Net::HTTP::VERSION != '%{rubygems_net_http_version}'; \
\""

# Net::Protocol.
make -C %{_vpath_builddir} -s runruby TESTRUN_SCRIPT="-e \" \
  module Gem; module Net; end; end; \
  require 'rubygems/vendor/net-protocol/lib/net/protocol'; \
  puts '%%{rubygems_net_protocol_version}: %{rubygems_net_protocol_version}'; \
  puts %Q[Gem::Net::Protocol::VERSION: #{Gem::Net::Protocol::VERSION}]; \
  exit 1 if Gem::Net::Protocol::VERSION != '%{rubygems_net_protocol_version}'; \
\""

# OptParse.
make -C %{_vpath_builddir} -s runruby TESTRUN_SCRIPT="-e \" \
  module Gem; end; \
  require 'rubygems/vendor/optparse/lib/optparse'; \
  puts '%%{rubygems_optparse_version}: %{rubygems_optparse_version}'; \
  puts %Q[Gem::OptionParser::Version: #{Gem::OptionParser::Version}]; \
  exit 1 if Gem::OptionParser::Version != '%{rubygems_optparse_version}'; \
\""

# Resolv.
make -C %{_vpath_builddir} -s runruby TESTRUN_SCRIPT="-e \" \
  module Gem; end; \
  require 'rubygems/vendor/resolv/lib/resolv'; \
  puts '%%{rubygems_resolv_version}: %{rubygems_resolv_version}'; \
  puts %Q[Gem::Resolv::VERSION: #{Gem::Resolv::VERSION}]; \
  exit 1 if Gem::Resolv::VERSION != '%{rubygems_resolv_version}'; \
\""

# SecureRandom.
make -C %{_vpath_builddir} -s runruby TESTRUN_SCRIPT="-e \" \
  module Gem; module Random; end; end; \
  require 'rubygems/vendor/securerandom/lib/securerandom'; \
  puts '%%{rubygems_securerandom_version}: %{rubygems_securerandom_version}'; \
  puts %Q[Gem::SecureRandom::VERSION: #{Gem::SecureRandom::VERSION}]; \
  exit 1 if Gem::SecureRandom::VERSION != '%{rubygems_securerandom_version}'; \
\""

# Timeout.
make -C %{_vpath_builddir} -s runruby TESTRUN_SCRIPT="-e \" \
  module Gem; end; \
  require 'rubygems/vendor/timeout/lib/timeout'; \
  puts '%%{rubygems_timeout_version}: %{rubygems_timeout_version}'; \
  puts %Q[Gem::Timeout::VERSION: #{Gem::Timeout::VERSION}]; \
  exit 1 if Gem::Timeout::VERSION != '%{rubygems_timeout_version}'; \
\""

# TSort
make -C %{_vpath_builddir} -s runruby TESTRUN_SCRIPT="-e \" \
  module Gem; end; \
  require 'rubygems/vendor/tsort/lib/tsort'; \
  puts '%%{rubygems_tsort_version}: %{rubygems_tsort_version}'; \
  puts %Q[Gem::TSort::VERSION: #{Gem::TSort::VERSION}]; \
  exit 1 if Gem::TSort::VERSION != '%{rubygems_tsort_version}'; \
\""

# URI.
make -C %{_vpath_builddir} -s runruby TESTRUN_SCRIPT="-e \" \
  module Gem; end; \
  require 'rubygems/vendor/uri/lib/uri/version'; \
  puts '%%{rubygems_uri_version}: %{rubygems_uri_version}'; \
  puts %Q[Gem::URI::VERSION: #{Gem::URI::VERSION}]; \
  exit 1 if Gem::URI::VERSION != '%{rubygems_uri_version}'; \
\""

# Check Bundler bundled dependencies versions.

# connection_pool.
make -C %{_vpath_builddir} -s runruby TESTRUN_SCRIPT="-e \" \
  module Bundler; end; \
  require 'bundler/vendor/connection_pool/lib/connection_pool/version'; \
  puts '%%{bundler_connection_pool_version}; %{bundler_connection_pool_version}'; \
  puts %Q[Bundler::ConnectionPool::VERSION: #{Bundler::ConnectionPool::VERSION}]; \
  exit 1 if Bundler::ConnectionPool::VERSION != '%{bundler_connection_pool_version}'; \
\""

# FileUtils.
make -C %{_vpath_builddir} -s runruby TESTRUN_SCRIPT="-e \" \
  module Bundler; end; \
  require 'bundler/vendor/fileutils/lib/fileutils'; \
  puts '%%{bundler_fileutils_version}: %{bundler_fileutils_version}'; \
  puts %Q[Bundler::FileUtils::VERSION: #{Bundler::FileUtils::VERSION}]; \
  exit 1 if Bundler::FileUtils::VERSION != '%{bundler_fileutils_version}'; \
\""

# PubGrub
make -C %{_vpath_builddir} -s runruby TESTRUN_SCRIPT="-e \" \
  module Bundler; end; \
  require 'bundler/vendor/pub_grub/lib/pub_grub/version'; \
  puts '%%{bundler_pub_grub_version}: %{bundler_pub_grub_version}'; \
  puts %Q[Bundler::PubGrub::VERSION: #{Bundler::PubGrub::VERSION}]; \
  exit 1 if Bundler::PubGrub::VERSION != '%{bundler_pub_grub_version}'; \
\""

# Net::HTTP::Persistent.
make -C %{_vpath_builddir} -s runruby TESTRUN_SCRIPT="-e \" \
  module Gem; end; \
  module Bundler; end; \
  require 'bundler/vendor/net-http-persistent/lib/net/http/persistent'; \
  puts '%%{bundler_net_http_persistent_version}: %{bundler_net_http_persistent_version}'; \
  puts %Q[Gem::Net::HTTP::Persistent::VERSION: #{Gem::Net::HTTP::Persistent::VERSION}]; \
  exit 1 if Gem::Net::HTTP::Persistent::VERSION != '%{bundler_net_http_persistent_version}'; \
\""

# SecureRandom.
make -C %{_vpath_builddir} -s runruby TESTRUN_SCRIPT="-e \" \
  module Bundler; module Random; end; end; \
  require 'bundler/vendor/securerandom/lib/securerandom'; \
  puts '%%{bundler_securerandom_version}: %{bundler_securerandom_version}'; \
  puts %Q[Bundler::SecureRandom::VERSION: #{Bundler::SecureRandom::VERSION}]; \
  exit 1 if Bundler::SecureRandom::VERSION != '%{bundler_securerandom_version}'; \
\""

# Thor.
make -C %{_vpath_builddir} -s runruby TESTRUN_SCRIPT="-e \" \
  module Bundler; end; \
  require 'bundler/vendor/thor/lib/thor/version'; \
  puts '%%{bundler_thor_version}: %{bundler_thor_version}'; \
  puts %Q[Bundler::Thor::VERSION: #{Bundler::Thor::VERSION}]; \
  exit 1 if Bundler::Thor::VERSION != '%{bundler_thor_version}'; \
\""

# TSort
make -C %{_vpath_builddir} -s runruby TESTRUN_SCRIPT="-e \" \
  module Bundler; end; \
  require 'bundler/vendor/tsort/lib/tsort'; \
  puts '%%{bundler_tsort_version}: %{bundler_tsort_version}'; \
  puts %Q[Bundler::TSort::VERSION: #{Bundler::TSort::VERSION}]; \
  exit 1 if Bundler::TSort::VERSION != '%{bundler_tsort_version}'; \
\""

# URI.
make -C %{_vpath_builddir} -s runruby TESTRUN_SCRIPT="-e \" \
  module Bundler; end; \
  require 'bundler/vendor/uri/lib/uri/version'; \
  puts '%%{bundler_uri_version}: %{bundler_uri_version}'; \
  puts %Q[Bundler::URI::VERSION: #{Bundler::URI::VERSION}]; \
  exit 1 if Bundler::URI::VERSION != '%{bundler_uri_version}'; \
\""

# Check bundled libraries versions.

# Nkf.
make -C %{_vpath_builddir} -s runruby TESTRUN_SCRIPT="-e \" \
  require 'rubygems'; \
  require 'nkf'; \
  puts '%%{bundled_nkf_version}: %{bundled_nkf_version}'; \
  puts %Q[NKF::NKF_VERSION: #{NKF::NKF_VERSION}]; \
  exit 1 if NKF::NKF_VERSION != '%{bundled_nkf_version}'; \
\""


# test_debug(TestRubyOptions) fails due to LoadError reported in debug mode,
# when abrt.rb cannot be required (seems to be easier way then customizing
# the test suite).
touch %{_vpath_builddir}/abrt.rb

# Check if abrt hook is required (RubyGems are disabled by default when using
# runruby, so re-enable them).
make -C %{_vpath_builddir} runruby TESTRUN_SCRIPT="--enable-gems %{SOURCE13}"

# Check if systemtap is supported.
%if %{with systemtap}
ln -sfr probes.d %{_vpath_builddir}/
make -C %{_vpath_builddir} runruby TESTRUN_SCRIPT=%{SOURCE14}
%endif

# Test dependency generators for RPM
GENERATOR_SCRIPT="%{SOURCE9}" \
make -C %{_vpath_builddir} runruby TESTRUN_SCRIPT=" \
  -I%{_builddir}/%{buildsubdir}/tool/lib -I%{_sourcedir} --enable-gems \
  %{SOURCE17} --verbose"
GENERATOR_SCRIPT="%{SOURCE10}" \
make -C %{_vpath_builddir} runruby TESTRUN_SCRIPT=" \
  -I%{_builddir}/%{buildsubdir}/tool/lib -I%{_sourcedir} --enable-gems \
  %{SOURCE18} --verbose"
GENERATOR_SCRIPT="%{SOURCE11}" \
make -C %{_vpath_builddir} runruby TESTRUN_SCRIPT=" \
  -I%{_builddir}/%{buildsubdir}/tool/lib -I%{_sourcedir} --enable-gems \
  %{SOURCE19} --verbose"


DISABLE_TESTS=""
MSPECOPTS=""

# Some tests are failing inside iurt due to failure to resolve the reverse of ::1
# Disable tests for now as they pass localy and all other tests pass but I am not sure
# how to disable those ones
exit 0

# Avoid `hostname' dependency.
%{!?with_hostname:MSPECOPTS="-P 'Socket.gethostname returns the host name'"}

# Give an option to increase the timeout in tests.
# https://bugs.ruby-lang.org/issues/16921
%{?test_timeout_scale:RUBY_TEST_TIMEOUT_SCALE="%{test_timeout_scale}"} \
  make -C %{_vpath_builddir} check TESTS="-v --show-skip $DISABLE_TESTS" MSPECOPT="-fs $MSPECOPTS"

%{?with_bundler_tests:make -C %{_vpath_builddir} test-bundler-parallel}

%pretrans io-console -p <lua>
st = posix.stat("%{ruby_libdir}/io")
if st and st.type == "directory" then
   os.remove("%{ruby_libdir}/io/console/size.rb")
   posix.rmdir("%{ruby_libdir}/io/console")
   posix.rmdir("%{ruby_libdir}/io")    
end

%pretrans psych -p <lua>
st = posix.stat("%{ruby_libdir}/psych")
if st and st.type == "directory" then
   os.execute("rm -rf %{ruby_libdir}/psych")
end

%files
%{_bindir}/ruby
%dir %{ruby_libdir}
# Use standalone ruby-racc if Racc binary is required. Shipping this
# executable in both packages might possibly cause conflicts. The situation
# could be better if Ruby generated these files:
# https://github.com/ruby/ruby/pull/2545
%exclude %{_bindir}/racc
%exclude %{gem_dir}/gems/racc-%{racc_version}/bin
%{ruby_libdir}/*.rb
%exclude %{ruby_libdir}/irb.rb
%exclude %{ruby_libdir}/json.rb
%exclude %{ruby_libdir}/psych.rb
%{ruby_libdir}/cgi
%{ruby_libdir}/did_you_mean
%{ruby_libdir}/digest
%{ruby_libdir}/erb
%{ruby_libdir}/error_highlight
%{ruby_libdir}/fiddle
%{ruby_libdir}/forwardable
%{ruby_libdir}/logger
%{ruby_libdir}/net
%{ruby_libdir}/objspace
%{ruby_libdir}/open3
%{ruby_libdir}/openssl
%{ruby_libdir}/optparse
%{ruby_libdir}/prism
%{ruby_libdir}/random
%{ruby_libdir}/reline
%{ruby_libdir}/ripper
%{ruby_libdir}/ruby_vm/rjit
%{ruby_libdir}/set
%{ruby_libdir}/strscan
%{ruby_libdir}/syntax_suggest
%{ruby_libdir}/unicode_normalize
%{ruby_libdir}/uri
%{ruby_libdir}/yaml
%dir %{ruby_libarchdir}
%dir %{ruby_libarchdir}/cgi
%{ruby_libarchdir}/cgi/escape.so
%{ruby_libarchdir}/continuation.so
%{ruby_libarchdir}/coverage.so
%{ruby_libarchdir}/date_core.so
%dir %{ruby_libarchdir}/digest
%{ruby_libarchdir}/digest.so
%{ruby_libarchdir}/digest/*.so
%dir %{ruby_libarchdir}/enc
%{ruby_libarchdir}/enc/*.so
%dir %{ruby_libarchdir}/enc/trans
%{ruby_libarchdir}/enc/trans/*.so
%{ruby_libarchdir}/erb/escape.so
%{ruby_libarchdir}/etc.so
%{ruby_libarchdir}/fcntl.so
%{ruby_libarchdir}/fiddle.so
%dir %{ruby_libarchdir}/io
%{ruby_libarchdir}/io/nonblock.so
%{ruby_libarchdir}/io/wait.so
%{ruby_libarchdir}/monitor.so
%{ruby_libarchdir}/objspace.so
%{ruby_libarchdir}/openssl.so
%{ruby_libarchdir}/pathname.so
%{ruby_libarchdir}/pty.so
%{ruby_libarchdir}/rbconfig.rb
%dir %{ruby_libarchdir}/rbconfig
%{ruby_libarchdir}/rbconfig/*.so
%{ruby_libarchdir}/ripper.so
%{ruby_libarchdir}/socket.so
%{ruby_libarchdir}/stringio.so
%{ruby_libarchdir}/strscan.so
%{ruby_libarchdir}/zlib.so
%{_mandir}/man1/ruby.1.*
%{_rpmconfigdir}/macros.d/macros.ruby
%{_datadir}/ruby/vendor_ruby
%{_libdir}/ruby/vendor_ruby

%{?with_systemtap:%{_systemtap_datadir}}

%gem_spec -d benchmark
%gem_spec -d cgi
%gem_spec -d date
%gem_spec -d delegate
%gem_spec -d did_you_mean
%gem_spec -d digest
%gem_spec -d english
%gem_spec -d erb
%gem_instdir erb
%{_bindir}/erb
%{_mandir}/man1/erb*
%gem_spec -d error_highlight
%gem_spec -d etc
%gem_spec -d fcntl
%gem_spec -d fiddle
%gem_spec -d fileutils
%gem_spec -d find
%gem_spec -d forwardable
%gem_spec -d io-nonblock
%gem_spec -d io-wait
%gem_spec -d ipaddr
%gem_spec -d logger
%gem_spec -d net-http
%gem_spec -d net-protocol
%gem_spec -d open3
%gem_spec -d open-uri
%gem_spec -d optparse
%gem_spec -d openssl
%gem_spec -d ostruct
%gem_spec -d pathname
%gem_spec -d pp
%gem_spec -d prettyprint
%gem_spec -d pstore
%gem_spec -d readline
%gem_spec -d reline
%gem_spec -d resolv
%gem_spec -d ruby2_keywords
%gem_spec -d securerandom
%gem_spec -d set
%gem_spec -d shellwords
%gem_spec -d singleton
%gem_spec -d stringio
%gem_spec -d strscan
%gem_spec -d syntax_suggest
%{_bindir}/syntax_suggest
%gem_instdir syntax_suggest
%gem_spec -d tempfile
%gem_spec -d time
%gem_spec -d timeout
%gem_spec -d tmpdir
%gem_spec -d tsort
%gem_spec -d un
%gem_spec -d uri
%gem_spec -d weakref
#%%gem_spec -d win32ole
%gem_spec -d yaml
%gem_spec -d prism
%gem_spec -d zlib

%files doc
%{_datadir}/ri
%{_datadir}/doc/ruby

%files -n %{libname}
%{_libdir}/libruby.so.%{subver}
%{_libdir}/libruby.so.%{rubyapi}

%files devel
%{_includedir}/*
%{_libdir}/libruby.so
%{_libdir}/pkgconfig/*.pc

%files irb
%{_bindir}/irb
%{ruby_libdir}/irb*
%{gem_instdir irb}
%{gem_spec irb}
%{_mandir}/man1/irb.1*

%files io-console
%{ruby_libdir}/io
%{ruby_libarchdir}/io/console.so
%{gem_extdir_mri io-console}
%{gem_instdir io-console}
%{gem_spec io-console}

%files RubyGems
%{_bindir}/gem
%{_rpmconfigdir}/macros.d/macros.rubygems
%dir %{rubygems_dir}
%{rubygems_dir}/rubygems
%{rubygems_dir}/rubygems.rb
%{_rpmconfigdir}/fileattrs/rubygems.attr
%{_rpmconfigdir}/rubygems.req
%{_rpmconfigdir}/rubygems.prov
%{_rpmconfigdir}/rubygems.con
%dir %{gem_dir}
%dir %{gem_dir}/build_info
%dir %{gem_dir}/cache
%dir %{gem_dir}/doc
%dir %{gem_dir}/extensions
%dir %{gem_dir}/gems
%dir %{gem_dir}/plugins
%dir %{gem_dir}/specifications
%dir %{gem_dir}/specifications/default
%dir %{_exec_prefix}/lib*/gems
%dir %{_exec_prefix}/lib*/gems/ruby
%exclude %{gem_dir}/cache/*

%files rdoc
%{_bindir}/rdoc
%{_bindir}/ri
%{gem_instdir rdoc}
%{gem_spec rdoc}
%{gem_plugin rdoc}
%{_mandir}/man1/ri*

%files json
%{ruby_libdir}/json*
%{ruby_libarchdir}/json*
%{gem_extdir_mri json}
%{gem_instdir json}
%{gem_spec json}

%files bigdecimal
%{gem_extdir_mri bigdecimal}
%{gem_instdir bigdecimal}
%{gem_spec bigdecimal}

%files psych
%{ruby_libdir}/psych
%{ruby_libdir}/psych.rb
%{ruby_libarchdir}/psych.so
%{gem_extdir_mri psych}
%dir %{gem_instdir psych}
%{gem_libdir psych}
%{gem_spec psych}
 
%files bundler
%{_bindir}/bundle
%{_bindir}/bundler
%{gem_instdir bundler}
%{gem_spec bundler}
%{_mandir}/man1/bundle*.1*
%{_mandir}/man5/gemfile.5*

%files bundled-gems
# abbrev
%dir %{gem_instdir abbrev}
%license %{gem_instdir abbrev}/LICENSE.txt
%{gem_instdir abbrev}/bin
%{gem_libdir abbrev}
%{gem_spec abbrev}
%{gem_instdir abbrev}/Gemfile
%doc %{gem_instdir abbrev}/README.md
%{gem_instdir abbrev}/Rakefile

# base64
%dir %{gem_instdir base64}
%license %{gem_instdir base64}/LICENSE.txt
%{gem_libdir base64}
%{gem_spec base64}
%doc %{gem_instdir base64}/README.md

# csv
%dir %{gem_instdir csv}
%license %{gem_instdir csv}/LICENSE.txt
%doc %{gem_instdir csv}/NEWS.md
%{gem_libdir csv}
%{gem_spec csv}
%doc %{gem_instdir csv}/README.md
%doc %{gem_instdir csv}/doc

# drb
%dir %{gem_instdir drb}
%license %{gem_instdir drb}/LICENSE.txt
%{gem_libdir drb}
%{gem_spec drb}

# getoptlong
%dir %{gem_instdir getoptlong}
%license %{gem_instdir getoptlong}/LICENSE.txt
%{gem_instdir getoptlong}/bin
%{gem_libdir getoptlong}
%{gem_instdir getoptlong}/sample
%{gem_spec getoptlong}
%{gem_instdir getoptlong}/Gemfile
%doc %{gem_instdir getoptlong}/README.md
%{gem_instdir getoptlong}/Rakefile

# matrix
%dir %{gem_instdir matrix}
%license %{gem_instdir matrix}/LICENSE.txt
%{gem_libdir matrix}
%{gem_spec matrix}

# mutex_m
%dir %{gem_instdir mutex_m}
%license %{gem_instdir mutex_m}/BSDL
%license %{gem_instdir mutex_m}/COPYING
%{gem_libdir mutex_m}
%{gem_instdir mutex_m}/sig
%{gem_spec mutex_m}
%doc %{gem_instdir mutex_m}/README.md

# net-ftp
%dir %{gem_instdir net-ftp}
%license %{gem_instdir net-ftp}/BSDL
%license %{gem_instdir net-ftp}/COPYING
%{gem_instdir net-ftp}/Gemfile
%license %{gem_instdir net-ftp}/LICENSE.txt
%doc %{gem_instdir net-ftp}/README.md
%{gem_instdir net-ftp}/Rakefile
%{gem_libdir net-ftp}
%{gem_spec net-ftp}

# net-imap
%dir %{gem_instdir net-imap}
%license %{gem_instdir net-imap}/BSDL
%license %{gem_instdir net-imap}/COPYING
%{gem_instdir net-imap}/Gemfile
%license %{gem_instdir net-imap}/LICENSE.txt
%doc %{gem_instdir net-imap}/README.md
%{gem_instdir net-imap}/Rakefile
%{gem_instdir net-imap}/docs
%{gem_libdir net-imap}
%{gem_instdir net-imap}/rakelib
%{gem_instdir net-imap}/sample
%{gem_spec net-imap}

# net-pop
%dir %{gem_instdir net-pop}
%{gem_instdir net-pop}/Gemfile
%license %{gem_instdir net-pop}/LICENSE.txt
%doc %{gem_instdir net-pop}/README.md
%{gem_instdir net-pop}/Rakefile
%{gem_libdir net-pop}
%{gem_spec net-pop}

# net-smtp
%dir %{gem_instdir net-smtp}
%doc %{gem_instdir net-smtp}/NEWS.md
%doc %{gem_instdir net-smtp}/README.md
%license %{gem_instdir net-smtp}/LICENSE.txt
%{gem_libdir net-smtp}
%{gem_spec net-smtp}

# nkf
%dir %{gem_instdir nkf}
%{gem_extdir_mri nkf}
%license %{gem_instdir nkf}/LICENSE.txt
%{gem_instdir nkf}/bin
%{gem_libdir nkf}
%{gem_spec nkf}
%{gem_instdir nkf}/Gemfile
%doc %{gem_instdir nkf}/README.md
%{gem_instdir nkf}/Rakefile

# observer
%dir %{gem_instdir observer}
%license %{gem_instdir observer}/LICENSE.txt
%{gem_instdir observer}/bin
%{gem_libdir observer}
%exclude %{gem_cache observer}
%{gem_spec observer}
%{gem_instdir observer}/Gemfile
%doc %{gem_instdir observer}/README.md
%{gem_instdir observer}/Rakefile

# prime
%dir %{gem_instdir prime}
%license %{gem_instdir prime}/BSDL
%license %{gem_instdir prime}/COPYING
%doc %{gem_instdir prime}/README.md
%{gem_instdir prime}/Rakefile
%{gem_libdir prime}
%{gem_instdir prime}/sig
%{gem_spec prime}

# rdbg
%{_bindir}/rdbg
%dir %{gem_extdir_mri debug}
%{gem_extdir_mri debug}/gem.build_complete
%dir %{gem_extdir_mri debug}/debug
%{gem_extdir_mri debug}/debug/debug.so
%dir %{gem_instdir debug}
%exclude %{gem_instdir debug}/.*
%doc %{gem_instdir debug}/CONTRIBUTING.md
%{gem_instdir debug}/Gemfile
%license %{gem_instdir debug}/LICENSE.txt
%doc %{gem_instdir debug}/README.md
%{gem_instdir debug}/Rakefile
%doc %{gem_instdir debug}/TODO.md
%{gem_instdir debug}/exe
%{gem_libdir debug}
%{gem_instdir debug}/misc
%{gem_spec debug}

# repl_type_completor
%dir %{gem_instdir repl_type_completor}
%license %{gem_instdir repl_type_completor}/LICENSE.txt
%{gem_libdir repl_type_completor}
%{gem_instdir repl_type_completor}/sig
%exclude %{gem_cache repl_type_completor}
%{gem_spec repl_type_completor}
%{gem_instdir repl_type_completor}/Gemfile
%doc %{gem_instdir repl_type_completor}/README.md
%{gem_instdir repl_type_completor}/Rakefile

# rinda
%dir %{gem_instdir rinda}
%license %{gem_instdir rinda}/LICENSE.txt
%{gem_instdir rinda}/bin
%{gem_libdir rinda}
%{gem_spec rinda}
%{gem_instdir rinda}/Gemfile
%doc %{gem_instdir rinda}/README.md
%{gem_instdir rinda}/Rakefile

# resolv-replace
%dir %{gem_instdir resolv-replace}
%license %{gem_instdir resolv-replace}/LICENSE.txt
%{gem_instdir resolv-replace}/bin
%{gem_libdir resolv-replace}
%{gem_spec resolv-replace}
%{gem_instdir resolv-replace}/Gemfile
%doc %{gem_instdir resolv-replace}/README.md
%{gem_instdir resolv-replace}/Rakefile

# syslog
%dir %{gem_instdir syslog}
%{gem_extdir_mri syslog}
%license %{gem_instdir syslog}/LICENSE.txt
%{gem_instdir syslog}/bin
%{gem_libdir syslog}
%exclude %{gem_cache syslog}
%{gem_spec syslog}
%{gem_instdir syslog}/Gemfile
%doc %{gem_instdir syslog}/README.md
%{gem_instdir syslog}/Rakefile

%files minitest
%dir %{gem_instdir minitest}
%exclude %{gem_instdir minitest}/.*
%{gem_instdir minitest}/Manifest.txt
%{gem_instdir minitest}/design_rationale.rb
%{gem_libdir minitest}
%{gem_spec minitest}
%doc %{gem_instdir minitest}/History.rdoc
%doc %{gem_instdir minitest}/README.rdoc
%{gem_instdir minitest}/Rakefile
%{gem_instdir minitest}/test

%files power_assert
%dir %{gem_instdir power_assert}
%exclude %{gem_instdir power_assert}/.*
%license %{gem_instdir power_assert}/BSDL
%license %{gem_instdir power_assert}/COPYING
%license %{gem_instdir power_assert}/LEGAL
%{gem_libdir power_assert}
%{gem_spec power_assert}
%{gem_instdir power_assert}/Gemfile
%doc %{gem_instdir power_assert}/README.md
%{gem_instdir power_assert}/Rakefile

%files rake
%{_bindir}/rake
%{gem_instdir rake}
%{gem_spec rake}
%{_mandir}/man1/rake.1*

%files rbs
%{_bindir}/rbs
%dir %{gem_extdir_mri rbs}
%{gem_extdir_mri rbs}/gem.build_complete
%{gem_extdir_mri rbs}/rbs_extension.so
%dir %{gem_instdir rbs}
%license %{gem_instdir rbs}/BSDL
%doc %{gem_instdir rbs}/CHANGELOG.md
%license %{gem_instdir rbs}/COPYING
%doc %{gem_instdir rbs}/README.md
%{gem_instdir rbs}/Rakefile
%{gem_instdir rbs}/Steepfile
%{gem_instdir rbs}/config.yml
%{gem_instdir rbs}/core
%doc %{gem_instdir rbs}/docs
%{gem_instdir rbs}/exe
%{gem_instdir rbs}/goodcheck.yml
%{gem_instdir rbs}/include
%{gem_libdir rbs}
%{gem_instdir rbs}/schema
%{gem_instdir rbs}/sig
%{gem_instdir rbs}/src
%{gem_instdir rbs}/stdlib
%{gem_instdir rbs}/templates
%{gem_spec rbs}

%files test-unit
%dir %{gem_instdir test-unit}
%license %{gem_instdir test-unit}/BSDL
%license %{gem_instdir test-unit}/COPYING
%license %{gem_instdir test-unit}/PSFL
%{gem_libdir test-unit}
%{gem_instdir test-unit}/sample
%{gem_spec test-unit}
%doc %{gem_instdir test-unit}/README.md
%{gem_instdir test-unit}/Rakefile
%doc %{gem_instdir test-unit}/doc

%files racc
%dir %{gem_instdir racc}
%{_bindir}/racc
%{gem_extdir_mri racc}
%license %{gem_instdir racc}/BSDL
%license %{gem_instdir racc}/COPYING
%doc %{gem_instdir racc}/ChangeLog
%lang(ja) %doc %{gem_instdir racc}/README.ja.rdoc
%doc %{gem_instdir racc}/README.rdoc
%doc %{gem_instdir racc}/TODO
%{gem_instdir racc}/bin
%doc %{gem_instdir racc}/doc
%{gem_libdir racc}
%{gem_spec racc}

%files rexml
%dir %{gem_instdir rexml}
%license %{gem_instdir rexml}/LICENSE.txt
%doc %{gem_instdir rexml}/NEWS.md
%doc %{gem_instdir rexml}/doc
%{gem_libdir rexml}
%{gem_spec rexml}
%doc %{gem_instdir rexml}/README.md

%files rss
%dir %{gem_instdir rss}
%exclude %{gem_instdir rss}/.*
%license %{gem_instdir rss}/LICENSE.txt
%doc %{gem_instdir rss}/NEWS.md
%{gem_libdir rss}
%{gem_spec rss}
%doc %{gem_instdir rss}/README.md

%files typeprof
%dir %{gem_instdir typeprof}
%{_bindir}/typeprof
%exclude %{gem_instdir typeprof}/.*
%license %{gem_instdir typeprof}/LICENSE
%{gem_instdir typeprof}/bin
%doc %{gem_instdir typeprof}/doc
%{gem_libdir typeprof}
%{gem_spec typeprof}
%doc %{gem_instdir typeprof}/README.md


%changelog
* Mon Mar 24 2025 pterjan <pterjan> 3.4.2-56.mga10
+ Revision: 2169395
- Update to 3.4.2

* Sat Feb 01 2025 pterjan <pterjan> 3.4.1-55.mga10
+ Revision: 2144140
- Fix rdoc generation when building gems

* Sat Feb 01 2025 pterjan <pterjan> 3.4.1-54.mga10
+ Revision: 2144111
- Update to 3.4.1

* Sat Dec 28 2024 wally <wally> 3.3.6-53.mga10
+ Revision: 2130919
- fix racc provides and obsoletes

* Fri Dec 06 2024 pterjan <pterjan> 3.3.6-52.mga10
+ Revision: 2122447
- Generate dependencies to fix many missing provides for default gems

* Fri Dec 06 2024 pterjan <pterjan> 3.3.6-51.mga10
+ Revision: 2122056
- Fix generator to not emit rich deps

* Thu Dec 05 2024 pterjan <pterjan> 3.3.6-50.mga10
+ Revision: 2121631
- Use lua for pretrans scriptlets

* Wed Dec 04 2024 pterjan <pterjan> 3.3.6-49.mga10
+ Revision: 2121524
- Fix gem_extdir_mri and some update conflicts

* Wed Dec 04 2024 pterjan <pterjan> 3.3.6-48.mga10
+ Revision: 2120854
- Fix build on armv7hl

* Tue Dec 03 2024 pterjan <pterjan> 3.3.6-47.mga10
+ Revision: 2120848
- Disable most tests for now
- Update to 3.3.6 and get the spec similar to Fedora

* Tue Nov 26 2024 ns80 <ns80> 3.1.5-46.mga10
+ Revision: 2118955
- Update rexml to 3.3.9 (CVE-2024-35176, CVE-2024-39908, CVE-2024-41123, CVE-2024-41946, CVE-2024-43398,CVE-2024-49761, mga33576)

* Thu May 02 2024 ns80 <ns80> 3.1.5-45.mga10
+ Revision: 2061860
- Bump release to get back all subpakages

* Sat Apr 27 2024 pterjan <pterjan> 3.1.5-44.mga10
+ Revision: 2061338
- Update to 3.1.5 as I am not ready for 3.3.1

* Thu Apr 13 2023 pterjan <pterjan> 3.1.4-44.mga9
+ Revision: 1952870
- Bump release to get back all subpakages

* Wed Apr 05 2023 pterjan <pterjan> 3.1.4-43.mga9
+ Revision: 1951512
- Update to 3.1.4 (CVE-2023-28755, CVE-2023-28756)

* Fri Dec 09 2022 pterjan <pterjan> 3.1.3-43.mga9
+ Revision: 1920101
- Disable minitest, we currently have a newer gem
- Update to 3.1.3 and sync some patches with Fedora

* Thu Apr 14 2022 pterjan <pterjan> 3.1.2-42.mga9
+ Revision: 1849372
- Fix build on armv7hl

* Thu Apr 14 2022 pterjan <pterjan> 3.1.2-41.mga9
+ Revision: 1849345
- Update to 3.1.2 and sync with Fedora on extension installation

* Fri Mar 25 2022 umeabot <umeabot> 3.1.0-40.mga9
+ Revision: 1825697
- Mageia 9 Mass Rebuild

* Sat Feb 26 2022 pterjan <pterjan> 3.1.0-39.mga9
+ Revision: 1785710
- Do not emit rich dependencies for ~>

* Fri Feb 25 2022 pterjan <pterjan> 3.1.0-38.mga9
+ Revision: 1784868
- Add missing provides of rubygem(racc)

* Fri Feb 25 2022 pterjan <pterjan> 3.1.0-37.mga9
+ Revision: 1784549
- Fix move of binary extensions on armv7hl

* Thu Feb 24 2022 pterjan <pterjan> 3.1.0-36.mga9
+ Revision: 1784231
- Commit again ruby 3.1.0, resolving an old minor conflict on ruby.spec reverted all my recent changes
- Install rubygems.con
- Update to 3.1.0 and get much closer to Fedora packaging to ease future updates
+ wally <wally>
- rebuild for openssl 3.0.0

* Thu Aug 05 2021 luigiwalser <luigiwalser> 2.7.2-35.mga9
+ Revision: 1739668
- rebuild for libffi
+ tv <tv>
- move macros into /usr/lib/rpm/macros.d/, /etc/rpm/macros.d is unofficial and
  we wan't to drop the patch for it
- Fix passing ldflags to gems

* Tue Apr 27 2021 pterjan <pterjan> 2.7.2-34.mga9
+ Revision: 1720163
- Rebuild to hopefully help with gcc commands name change

* Tue Nov 10 2020 pterjan <pterjan> 2.7.2-33.mga8
+ Revision: 1644398
- Dependency generator now wants ruby(release) which is the package with ruby libs

* Sat Oct 17 2020 pterjan <pterjan> 2.7.2-32.mga8
+ Revision: 1636656
- Update to 2.7.2

* Mon Jun 22 2020 joequant <joequant> 2.7.1-31.mga8
+ Revision: 1598468
- rebuild

* Sun Jun 21 2020 wally <wally> 2.7.1-30.mga8
+ Revision: 1598349
- add patch to fix build with autoconf git
+ martinw <martinw>
- rebuild for new libffi major

* Sun Apr 05 2020 pterjan <pterjan> 2.7.1-29.mga8
+ Revision: 1564990
- Revert accidental changes to uby-2.1.0-custom-rubygems-location.patch
- Update to 2.7.1

* Sat Mar 28 2020 pterjan <pterjan> 2.7.0-28.mga8
+ Revision: 1561998
- Disable minitest, the gem was updated to a new version
- Fix racc accidentally also being in bundler
- Stop building racc, gem has been updated to a newer version

* Wed Mar 04 2020 pterjan <pterjan> 2.7.0-27.mga8
+ Revision: 1553852
- Set cflags/cxxflags/ldflags when building gems

* Mon Mar 02 2020 pterjan <pterjan> 2.7.0-26.mga8
+ Revision: 1553058
- Require did_you_mean which is unfortunately mandatory

* Mon Mar 02 2020 pterjan <pterjan> 2.7.0-25.mga8
+ Revision: 1553045
- Update gem_build to use --document=ri,rdoc instead of --rdoc --ri

* Mon Mar 02 2020 pterjan <pterjan> 2.7.0-24.mga8
+ Revision: 1553038
- Fix some directories replaced with symlinks

* Mon Mar 02 2020 pterjan <pterjan> 2.7.0-23.mga8
+ Revision: 1552752
- Sync a bit more with fedora, in particular moving some files to a better place
- Update file lists and various other fixes
- Add some test workarounds from Fedora
- Update to 2.7.0 and sync patches from Fedora

* Wed Feb 19 2020 umeabot <umeabot> 2.5.7-22.mga8
+ Revision: 1542336
- Mageia 8 Mass Rebuild
+ wally <wally>
- replace deprecated %%configure2_5x

* Sat Jan 04 2020 luigiwalser <luigiwalser> 2.5.7-21.mga8
+ Revision: 1476009
- rebuild for readline
+ wally <wally>
- replace deprecated %%makeinstall_std

* Sun Dec 22 2019 pterjan <pterjan> 2.5.7-20.mga8
+ Revision: 1469562
- Add upstream patch fixing tests with recent openssl
- Update to 2.5.7 (my work on 2.6.5 is still not finished and 2.7 is arriving this month...)

* Sun Oct 21 2018 pterjan <pterjan> 2.5.3-20.mga7
+ Revision: 1323468
- Update to 2.5.3

* Sun Sep 23 2018 umeabot <umeabot> 2.5.1-19.mga7
+ Revision: 1300870
- Mageia 7 Mass Rebuild

* Sun Jun 17 2018 luigiwalser <luigiwalser> 2.5.1-18.mga7
+ Revision: 1237492
- rebuild for gdbm

* Sun Apr 29 2018 pterjan <pterjan> 2.5.1-17.mga7
+ Revision: 1223656
- Drop rdoc, we have a newer gem
- Update to 2.5.1
+ wally <wally>
- sync .spec a bit with Fedora for aarch64
- add patch from upstream to increase timeout for test_clear_unreachable_keyword_args to fix aarch64 build error

* Sat Jan 06 2018 pterjan <pterjan> 2.5.0-16.mga7
+ Revision: 1190623
- Sync patches with Fedora

* Mon Jan 01 2018 pterjan <pterjan> 2.5.0-8.mga7
+ Revision: 1188892
- Adapt upstream patch to fix a segfault

* Mon Jan 01 2018 pterjan <pterjan> 2.5.0-7.mga7
+ Revision: 1188465
- Rebuild for Ruby 2.5

* Sun Dec 31 2017 pterjan <pterjan> 2.5.0-6.mga7
+ Revision: 1188444
- Fix my workaround...

* Sun Dec 31 2017 pterjan <pterjan> 2.5.0-5.mga7
+ Revision: 1188438
- Workaround loadpath issue

* Sun Dec 31 2017 pterjan <pterjan> 2.5.0-4.mga7
+ Revision: 1188425
- Increase release as net-telnet didn't change version
- Update to 2.5.0

* Sat Dec 30 2017 luigiwalser <luigiwalser> 2.4.3-3.mga7
+ Revision: 1188060
- 2.4.3

* Sun Dec 03 2017 josh <josh> 2.4.2-2.mga7
+ Revision: 1180909
- Bump version to rebuild against libreadline.so.7
- Replace devel BuildRequires with pkgconfig

* Thu Oct 05 2017 pterjan <pterjan> 2.4.2-1.mga7
+ Revision: 1169199
- Fix file lists
- Update openssl version
- fix lib version
- Update to 2.4.2

* Sun Sep 17 2017 pterjan <pterjan> 2.4.1-15.mga7
+ Revision: 1155105
- Fix tests failing on the build system
- Fix build with some disabled extensions and restore tests
- json is now in a separate package

* Thu Sep 14 2017 pterjan <pterjan> 2.4.1-14.mga7
+ Revision: 1153712
- Add missing openssl.rb

* Sat Sep 02 2017 pterjan <pterjan> 2.4.1-13.mga7
+ Revision: 1150973
- Require rubygems, ruby is very upset without it

* Fri Sep 01 2017 pterjan <pterjan> 2.4.1-12.mga7
+ Revision: 1150389
- I failed to disable the building of unwanted extensions/gems so exclude the files
- Disable more updated subpackages
- Fix doubly packages psych files
- Disable rubygems package to update it separately
- Few more moves
- Move more things to rubygems package
- Move back rubygems.macros to rubygems package

* Tue Aug 15 2017 pterjan <pterjan> 2.4.1-9.mga7
+ Revision: 1141087
- Add macros from fedora to add/remove gem dependencies

* Tue Aug 15 2017 pterjan <pterjan> 2.4.1-8.mga7
+ Revision: 1140696
- Add one more dependency

* Tue Aug 15 2017 pterjan <pterjan> 2.4.1-7.mga7
+ Revision: 1140659
- gem install into BUILD dir, build in the build section, and manually copy files. That fixes finding sources for debuginfo

* Tue Aug 15 2017 pterjan <pterjan> 2.4.1-6.mga7
+ Revision: 1140636
- Add another missing dependency
- Make gem install verbose and use --build-root
- Add another missing dependency

* Mon Aug 14 2017 pterjan <pterjan> 2.4.1-5.mga7
+ Revision: 1140361
- Manually add dependencies, they generators are in this package which is not installed during build

* Mon Aug 14 2017 pterjan <pterjan> 2.4.1-4.mga7
+ Revision: 1140339
- Fix json conflict
- Fix file list
- Add back rubygems.macros

* Mon Aug 14 2017 pterjan <pterjan> 2.4.1-2.mga7
+ Revision: 1140286
- Fix group

* Mon Aug 14 2017 pterjan <pterjan> 2.4.1-1.mga7
+ Revision: 1140278
- Fix file list
- Move json.rb to the right subpackage
- Fix some missed renames
- Simplify package, always bootstrap (fixes gem tests), and add new packages
- tk is gone
- Disable one more gem test, I still haven't found why they fail
- Use gem_dir instead of gems_dir, to be closer to fedora, and use global in more places
- Revert some local tests
- Update to 2.4.1 and pull in a bunch a Fedora changes
- Backport fix for CVE-2016-2339
- Update to latest bugfix release of 2.2 branch
- Run all tests during build (except the gem ones that need to be checked/fixed)
- Fix test_empty_data with CVE-2016-7798 patch

* Sun Oct 09 2016 pterjan <pterjan> 2.2.5-15.mga6
+ Revision: 1059716
- Add patch for CVE-2016-7798

* Thu Sep 08 2016 luigiwalser <luigiwalser> 2.2.5-14.mga6
+ Revision: 1050451
- 2.2.5 (sync with f22)

* Thu Mar 03 2016 umeabot <umeabot> 2.2.4-13.mga6
+ Revision: 984820
- Rebuild for openssl
+ pterjan <pterjan>
- Please perl-Youri-Package-RPM-Updater

* Tue Dec 29 2015 pterjan <pterjan> 2.2.4-12.mga6
+ Revision: 916704
- Bump release for subpackages which did not change version :(
- Update to 2.2.4
- Rever the io-console change, separate gem is older
- Don't ship io-console, we have a separate package

* Sat Dec 19 2015 pterjan <pterjan> 2.2.3-11.mga6
+ Revision: 912333
- Do not ship rake.rb, rdoc.rb and psych.rb in main package

* Sun Nov 01 2015 pterjan <pterjan> 2.2.3-10.mga6
+ Revision: 897270
- Ship all subpackages that are not packages separately

* Sat Oct 24 2015 pterjan <pterjan> 2.2.3-9.mga6
+ Revision: 895045
- Fix dependencies and disable gem subpackages

* Fri Oct 23 2015 pterjan <pterjan> 2.2.3-8.mga6
+ Revision: 894524
- Avoid file conflicts

* Fri Oct 23 2015 pterjan <pterjan> 2.2.3-7.mga6
+ Revision: 894486
- Force provides
- Provide the same ruby(abi) that we require

* Fri Oct 23 2015 pterjan <pterjan> 2.2.3-6.mga6
+ Revision: 894469
- Rebuild 2/2 to get proper dependencies

* Fri Oct 23 2015 pterjan <pterjan> 2.2.3-5.mga6
+ Revision: 894465
- Rebuild 1/2 to get proper dependencies
- Update gems path in the dependency extractor

* Fri Oct 23 2015 pterjan <pterjan> 2.2.3-4.mga6
+ Revision: 894460
- re enable bootstrap
- use the defined release_string macro (and fix it)
- build gems to allow bootstrap
- various fixes and cleanups, not yet tested if more are needed
+ blino <blino>
- rebuild with bootstrap since RubyGems should be installable again

* Fri Oct 23 2015 blino <blino> 2.2.3-2.mga6
+ Revision: 894369
- remove gems cache (build was failing only in bootstrap mode before, now fails everytime since we do not install bundles in removed home dir anymore)
- stop removing gem dir in home now that all install paths should be ok
- update do-not-install-to-user-dir to handle bundle gems as well
- rebuild in bootstrap mode to be able to rebuild ruby-json which is required by ruby-RubyGems and thus ruby
+ pterjan <pterjan>
- Fix file list
- Fix regex

* Wed Oct 21 2015 shlomif <shlomif> 2.2.3-1.mga6
+ Revision: 893775
- New version 2.2.3 - synced in part from Fedora.
+ pterjan <pterjan>
- Fix dependency extraction
- Better patch fix for bootstrap

* Sat Oct 17 2015 pterjan <pterjan> 2.0.0.p645-5.mga6
+ Revision: 892281
- Define gems_dir in ruby package as it is used in rubygems.attr and we don't require Rubygems in bootstrap mode

* Fri Oct 16 2015 pterjan <pterjan> 2.0.0.p645-4.mga6
+ Revision: 892256
- fix user-dir patch to work in bootstrap

* Sun Oct 11 2015 pterjan <pterjan> 2.0.0.p645-3.mga6
+ Revision: 889596
- Add upstream patch to support Tk 8.6
+ tv <tv>
- rebuild for tk 8.6
+ daviddavid <daviddavid>
- rebuild for new tcl/tk 8.6.4

* Thu Apr 30 2015 pterjan <pterjan> 2.0.0.p645-1.mga5
+ Revision: 820881
- Drop applied patch
- Update to p645 (CVE-2015-1855)

* Fri Nov 14 2014 pterjan <pterjan> 2.0.0.p598-1.mga5
+ Revision: 796908
- Update to 2.0.0-p598 (CVE-2014-8090)
+ luigiwalser <luigiwalser>
- add upstream patch to fix CVE-2014-4975

* Mon Oct 27 2014 pterjan <pterjan> 2.0.0.p594-1.mga5
+ Revision: 793866
- 2.0.0-p594 (CVE-2014-8080 + Insecure SSL/TLS options are now turn off by default + many bug fixes)

* Wed Oct 15 2014 umeabot <umeabot> 2.0.0.p451-6.mga5
+ Revision: 748136
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 2.0.0.p451-5.mga5
+ Revision: 688736
- Mageia 5 Mass Rebuild

* Thu Sep 11 2014 tv <tv> 2.0.0.p451-4.mga5
+ Revision: 674762
- move rubygem req/prov generator in ruby instead of -devel subpackage
  (this one is actually required by gems but not always -devel)

* Mon Sep 08 2014 tv <tv> 2.0.0.p451-3.mga5
+ Revision: 673709
- add RPM dependency generators for RubyGems

* Mon Apr 21 2014 pterjan <pterjan> 2.0.0.p451-2.mga5
+ Revision: 617250
- Fix version in pkg-config file (mga#13240)

* Mon Mar 10 2014 pterjan <pterjan> 2.0.0.p451-1.mga5
+ Revision: 601635
- Add upstream patch to fix build with new readline
- Patch to force installing bundled gems to system directory even if build is running as user
- Drop patch already applied
- Add fedora patch preventing potential multilib conflict
- Update to p451

* Fri Dec 27 2013 pterjan <pterjan> 2.0.0.p247-8.mga4
+ Revision: 560987
- Fix use of wrong macro now that they are different
- Move rubygems out of gems dir as this brakes bundler

* Sat Nov 23 2013 fwang <fwang> 2.0.0.p247-7.mga4
+ Revision: 552441
- add upstream patch to fix CVE-2013-4164

* Mon Oct 21 2013 umeabot <umeabot> 2.0.0.p247-6.mga4
+ Revision: 538717
- Mageia 4 Mass Rebuild

* Wed Oct 02 2013 fwang <fwang> 2.0.0.p247-5.mga4
+ Revision: 490240
- fix issues with DESTDIR (patch from fedora)
+ pterjan <pterjan>
- Switch to Ruby 2
- Grrr failed again

* Wed Aug 21 2013 fwang <fwang> 2.0.0.p247-4.mga4
+ Revision: 468908
- do not build bootstrap
- rebuild to drop temporary obsoletes
- temporarily obsolete newly built packages
- move into current

